# サンプルコード対応表

本文記載のサンプルコード一覧です。

一部のソースコードは、コンパイルを通すために、本文にはないコードを追加しております。
また、一部の極めて小さなコードは、サンプルコードとして用意しておりません。

ご了承ください。

## 1章 悪しき構造の弊害を知覚する

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 1.1 | src/chapter01_failuredesigndigest/technicalname/MemoryStateManager.java |
| 1.2 | src/chapter01_failuredesigndigest/numberingname/Class001.java |
| 1.3 | src/chapter08_conditionbranch/earlyreturn/v1/NestedLogic.java |
| 1.5 | src/chapter01_failuredesigndigest/dataclass/ContractAmount.java |
| 1.6 | src/chapter01_failuredesigndigest/dataclass/ContractManager.java |

## 2章 設計の初歩

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 2.1 | src/chapter02_designfirststep/damage/v1/DamageLogic.java |
| 2.2 | src/chapter02_designfirststep/damage/v2/DamageLogic.java |
| 2.3 | src/chapter02_designfirststep/damage/v3/DamageLogic.java |
| 2.4, 2.5 | src/chapter02_designfirststep/damage/v4/DamageLogic.java |
| 2.6, 2.7, 2.8 | src/chapter02_designfirststep/hitpoint/v1/HitPointLogic.java |
| 2.9 | src/chapter02_designfirststep/hitpoint/v2/HitPoint.java |

## 3章 カプセル化の基礎 ―ひとつにまとめる―

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 3.18 | src/chapter03_encapsulationbasic/Money.java |
| 3.19 | src/chapter03_encapsulationbasic/Money.rb |

## 4章 不変の活用 ―安定動作を構築する―

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 4.1 | src/chapter04_immutable/reassigning/v1/DamageLogic.java |
| 4.3 | src/chapter04_immutable/reassigning/v2/DamageLogic.java |
| 4.4 | src/chapter04_immutable/finalparam/v1/MutableParamLogic.java |
| 4.5 | src/chapter04_immutable/finalparam/v2/ImmutableParamLogic.java |
| 4.6 | src/chapter04_immutable/sideeffect/v1/AttackPower.java |
| 4.7 | src/chapter04_immutable/sideeffect/v1/Weapon.java |
| 4.8, 4.9, 4.11 | src/chapter04_immutable/sideeffect/v1/ProcessLogic.java |
| 4.13 | src/chapter04_immutable/sideeffect/v2/AttackPower.java |
| 4.14, 4.17 | src/chapter04_immutable/sideeffect/v2/ProcessLogic.java |
| 4.18 | src/chapter04_immutable/sideeffect/v3/AttackPower.java |
| 4.19, 4.20, 4.22 | src/chapter04_immutable/sideeffect/v3/ProcessLogic.java |
| 4.21 | src/chapter04_immutable/sideeffect/v3/Weapon.java |
| 4.24 | src/chapter04_immutable/mutator/v1/ |
| 4.25 | src/chapter04_immutable/mutator/v2/ |

## 5章 バラバラなデータとロジックをカプセル化する実践技法

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 5.1 | src/chapter05_encapsulationpractices/primitiveobsession/v1/Common.java |
| 5.2 | src/chapter05_encapsulationpractices/primitiveobsession/v1/Util.java |
| 5.3 | src/chapter05_encapsulationpractices/primitiveobsession/v2/RegularPrice.java |
| 5.4 | src/chapter05_encapsulationpractices/primitiveobsession/v2/DiscountedPrice.java |
| 5.5 | src/chapter05_encapsulationpractices/staticmiss/OrderManager.java |
| 5.6 | src/chapter05_encapsulationpractices/staticmiss/OrderLogic.java |
| 5.7 | src/chapter05_encapsulationpractices/staticmiss/PaymentManager.java |
| 5.8 | src/chapter05_encapsulationpractices/gift/v1/GiftPoint.java |
| 5.9, 5.10 | src/chapter05_encapsulationpractices/gift/v1/GiftLogic.java |
| 5.11 | src/chapter05_encapsulationpractices/gift/v2/GiftPoint.java |
| 5.12, 5.13 | src/chapter05_encapsulationpractices/gift/v2/GiftLogic.java |
| 5.14 | src/chapter05_encapsulationpractices/common/Common.java |
| 5.16 | src/chapter05_encapsulationpractices/common/AmountIncludingTax.java |
| 5.17 | src/chapter05_encapsulationpractices/crosscutting/LoggerLogic.java |
| 5.18 | src/chapter05_encapsulationpractices/location/v1/ActorManager.java |
| 5.21 | src/chapter05_encapsulationpractices/location/v1/DiscountManager.java |
| 5.22 | src/chapter05_encapsulationpractices/location/v2/Location.java |
| 5.24 | src/chapter05_encapsulationpractices/outkeyword/RecoverCompletely.cs |
| 5.25 | src/chapter05_encapsulationpractices/outkeyword/HitPoint.cs |
| 5.27 | src/chapter05_encapsulationpractices/magic/v1/RecoverMagicPointMethod.java |
| 5.29 | src/chapter05_encapsulationpractices/magic/v2/MagicPoint.java |
| 5.31 | src/chapter05_encapsulationpractices/accesschain/Equipments.java |

## 6章 関心の分離という考え方 ―分けて整理する―

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 6.1 | src/chapter06_separationofconcernsbasic/util/v1/Util.java |
| 6.2 | src/chapter06_separationofconcernsbasic/util/v2/Reservation.java |
| 6.3 | src/chapter06_separationofconcernsbasic/util/v2/ViewCustomizing.java |
| 6.4 | src/chapter06_separationofconcernsbasic/util/v2/MailMagazineService.java |
| 6.5 | src/chapter06_separationofconcernsbasic/selling/good/SellingPrice.java |
| 6.6 | src/chapter06_separationofconcernsbasic/selling/bad/SellingPrice.java |
| 6.7 | src/chapter06_separationofconcernsbasic/selling/good/SellingCommission.java |
| 6.8 | src/chapter06_separationofconcernsbasic/selling/good/DeliveryCharge.java |
| 6.9 | src/chapter06_separationofconcernsbasic/selling/good/ShoppingPoint.java |
| 6.10 | src/chapter06_separationofconcernsbasic/weaponbreak/bad/AttackUseCase.java |
| 6.16 | src/chapter06_separationofconcernsbasic/weaponbreak/good/Damage.java |
| 6.17 | src/chapter06_separationofconcernsbasic/weaponbreak/good/Weapon.java |
| 6.18 | src/chapter06_separationofconcernsbasic/weaponbreak/good/SpecialGauge.java |
| 6.19 | src/chapter06_separationofconcernsbasic/weaponbreak/good/AttackUseCase.java |

## 7章 関心が混ざったコードを分けて整理する実践技法

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 7.1 | src/chapter07_separationofconcernspractices/discount/v1/DiscountManager.java |
| 7.2 | src/chapter07_separationofconcernspractices/discount/v1/SummerDiscountManager.java |
| 7.3 | src/chapter07_separationofconcernspractices/discount/v2/DiscountLogic.java |
| 7.4 | src/chapter07_separationofconcernspractices/discount/v3/RegularPrice.java |
| 7.5 | src/chapter07_separationofconcernspractices/discount/v3/RegularDiscountedPrice.java |
| 7.6 | src/chapter07_separationofconcernspractices/discount/v3/SummerDiscountedPrice.java |
| 7.7 | src/chapter07_separationofconcernspractices/attack/bad/PhysicalAttack.java |
| 7.8 | src/chapter07_separationofconcernspractices/attack/bad/FighterPhysicalAttack.java |
| 7.9 | src/chapter07_separationofconcernspractices/attack/good/FighterPhysicalAttack.java |
| 7.10 | src/chapter07_separationofconcernspractices/commonextend/v1/DiscountBase.java |
| 7.13 | src/chapter07_separationofconcernspractices/commonextend/v1/RegularDiscount.java |
| 7.14 | src/chapter07_separationofconcernspractices/commonextend/v2/DiscountBase.java |
| 7.15 | src/chapter07_separationofconcernspractices/commonextend/v2/RegularDiscount.java |
| 7.16 | src/chapter07_separationofconcernspractices/commonextend/v2/SummerDiscount.java |
| 7.17 | src/chapter07_separationofconcernspractices/commonextend/v3/DiscountBase.java |
| 7.18 | src/chapter07_separationofconcernspractices/visibility/v1/HitPointRecovery.java |
| 7.19 | src/chapter07_separationofconcernspractices/visibility/v1/PositiveFeelings.java |
| 7.20 | src/chapter07_separationofconcernspractices/visibility/v1/BattleView.java |
| 7.21 | src/chapter07_separationofconcernspractices/visibility/v2/PositiveFeelings.java |
| 7.22 | src/chapter07_separationofconcernspractices/order/OrderService.java |
| 7.23 | src/chapter07_separationofconcernspractices/hugedata/Order.java |

## 8章 条件分岐 ―迷宮化した分岐処理を解きほぐす技法―

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 8.1 | src/chapter08_conditionbranch/earlyreturn/v1/NestedLogic.java |
| 8.3 | src/chapter08_conditionbranch/earlyreturn/v2/NestedLogic.java |
| 8.4 | src/chapter08_conditionbranch/earlyreturn/v3/NestedLogic.java |
| 8.5 | src/chapter08_conditionbranch/earlyreturn/v4/NestedLogic.java |
| 8.6 | src/chapter08_conditionbranch/earlyreturn/v5/NestedLogic.java |
| 8.7 | src/chapter08_conditionbranch/elsekeyword/v1/ElseLogic.java |
| 8.8 | src/chapter08_conditionbranch/elsekeyword/v2/ElseLogic.java |
| 8.9 | src/chapter08_conditionbranch/elsekeyword/v3/ElseLogic.java |
| 8.10 | src/chapter08_conditionbranch/switchcase/magic/MagicType.java |
| 8.11, 8.12, 8.13 | src/chapter08_conditionbranch/switchcase/magic/v1/MagicManager.java |
| 8.14, 8.15, 8.16, 8.17 | src/chapter08_conditionbranch/switchcase/magic/v2/MagicManager.java |
| 8.18 | src/chapter08_conditionbranch/switchcase/magic/v3/Magic.java |
| 8.19 | src/chapter08_conditionbranch/switchcase/measurement/v1/Rectangle.java |
| 8.19 | src/chapter08_conditionbranch/switchcase/measurement/v1/Circle.java |
| 8.22 | src/chapter08_conditionbranch/switchcase/measurement/v1/ShowAreaLogic.java |
| 8.23 | src/chapter08_conditionbranch/switchcase/measurement/v2/Measurement.java |
| 8.26 | src/chapter08_conditionbranch/switchcase/measurement/v2/Rectangle.java |
| 8.27 | src/chapter08_conditionbranch/switchcase/measurement/v2/Circle.java |
| 8.31 | src/chapter08_conditionbranch/switchcase/magic/v4/MagicAttack.java |
| 8.32 | src/chapter08_conditionbranch/switchcase/magic/v4/Fire.java |
| 8.33 | src/chapter08_conditionbranch/switchcase/magic/v4/Shiden.java |
| 8.34 | src/chapter08_conditionbranch/switchcase/magic/v4/HellFire.java |
| 8.35, 8.36 | src/chapter08_conditionbranch/switchcase/magic/v4/MagicSwitch.java |
| 8.37 | src/chapter08_conditionbranch/switchcase/magic/v4/MagicSwitchV2.java |
| 8.40 | src/chapter08_conditionbranch/switchcase/magic/v5/MagicAttack.java |
| 8.41 | src/chapter08_conditionbranch/switchcase/magic/v5/Fire.java |
| 8.42 | src/chapter08_conditionbranch/switchcase/magic/v5/Shiden.java |
| 8.43 | src/chapter08_conditionbranch/switchcase/magic/v5/HellFire.java |
| 8.44 | src/chapter08_conditionbranch/memberrank/CustomerBenefit.java |
| 8.45 | src/chapter08_conditionbranch/memberrank/NormalCustomerBenefit.java |
| 8.46 | src/chapter08_conditionbranch/memberrank/SilverCustomerBenefit.java |
| 8.47 | src/chapter08_conditionbranch/memberrank/GoldCustomerBenefit.java |
| 8.48 | src/chapter08_conditionbranch/memberrank/CustomerRank.java |
| 8.49 | src/chapter08_conditionbranch/memberrank/CustomerBenefits.java |
| 8.50 | src/chapter08_conditionbranch/memberrank/ApplyYearlyPointBonusUseCase.java |
| 8.51, 8.52 | src/chapter08_conditionbranch/policy/v1/CustomerRankLogic.java |
| 8.53 | src/chapter08_conditionbranch/policy/v2/ExcellentCustomerRule.java |
| 8.54 | src/chapter08_conditionbranch/policy/v2/GoldCustomerPurchaseAmountRule.java |
| 8.55 | src/chapter08_conditionbranch/policy/v2/PurchaseFrequencyRule.java |
| 8.56 | src/chapter08_conditionbranch/policy/v2/ReturnRateRule.java |
| 8.57 | src/chapter08_conditionbranch/policy/v2/ExcellentCustomerPolicy.java |
| 8.58 | src/chapter08_conditionbranch/policy/v2/CallExcellentCustomerPolicyLogic.java |
| 8.59 | src/chapter08_conditionbranch/policy/v2/GoldCustomerPolicy.java |
| 8.60 | src/chapter08_conditionbranch/policy/v2/SilverCustomerPolicy.java |
| 8.61 | src/chapter08_conditionbranch/hotelrate/v1/HotelRates.java |
| 8.62 | src/chapter08_conditionbranch/hotelrate/v1/RegularRates.java |
| 8.63 | src/chapter08_conditionbranch/hotelrate/v1/PremiumRates.java |
| 8.64 | src/chapter08_conditionbranch/hotelrate/v1/TypeCheckLogic.java |
| 8.65 | src/chapter08_conditionbranch/hotelrate/v2/HotelRates.java |
| 8.66 | src/chapter08_conditionbranch/hotelrate/v2/RegularRates.java |
| 8.67 | src/chapter08_conditionbranch/hotelrate/v2/PremiumRates.java |
| 8.68 | src/chapter08_conditionbranch/hotelrate/v2/CallHotelRatesLogic.java |
| 8.70 | src/chapter08_conditionbranch/flagvariable/v1/FlagLogic.java |
| 8.71 | src/chapter08_conditionbranch/flagvariable/v1/SelectorLogic.java |
| 8.72 | src/chapter08_conditionbranch/flagvariable/v2/DamageLogic.java |
| 8.73 | src/chapter08_conditionbranch/flagvariable/v3/Damage.java |
| 8.74 | src/chapter08_conditionbranch/flagvariable/v3/HitPointDamage.java |
| 8.74 | src/chapter08_conditionbranch/flagvariable/v3/MagicPointDamage.java |
| 8.75 | src/chapter08_conditionbranch/flagvariable/v3/DamageType.java |
| 8.75 | src/chapter08_conditionbranch/flagvariable/v3/ApplyDamageLogic.java |

## 9章 コレクション ―ネストを解消する構造化技法―

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 9.1 | src/chapter09_collection/prison/v1/PrisonLogic.java |
| 9.2 | src/chapter09_collection/prison/v2/PrisonLogic.java |
| 9.3 | src/chapter09_collection/earlycontinue/v1/Logic.java |
| 9.4 | src/chapter09_collection/earlycontinue/v2/Logic.java |
| 9.5 | src/chapter09_collection/earlycontinue/v3/Logic.java |
| 9.6 | src/chapter09_collection/earlybreak/v1/Logic.java |
| 9.7 | src/chapter09_collection/earlybreak/v2/Logic.java |
| 9.8 | src/chapter09_collection/party/v1/FieldManager.java |
| 9.10 | src/chapter09_collection/party/v1/BattleManager.java |
| 9.14 | src/chapter09_collection/party/v2/Party.java |

## 10章 設計の健全性をそこなうさまざまな悪魔たち

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 10.1 | src/chapter10_unhealthycode/DeadCode.java |
| 10.2 | src/chapter10_unhealthycode/comic/ComicManager.java |
| 10.3 | src/chapter10_unhealthycode/comic/ReadingPoint.java |
| 10.6, 10.7, 10.8 | src/chapter10_unhealthycode/nullproblem/v1/Member.java |
| 10.10 | src/chapter10_unhealthycode/nullproblem/v1/ShowLogic.java |
| 10.11 | src/chapter10_unhealthycode/nullproblem/v2/Equipment.java |
| 10.16 | src/chapter10_unhealthycode/level/Level.java |
| 10.17 | src/chapter10_unhealthycode/level/MetaproLogic.java |
| 10.20, 10.21 | src/chapter10_unhealthycode/usergenerate/GenerateLogic.java |

## 11章 名前設計 ―あるべき構造を見破る名前―

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 11.1 | src/chapter11_namedesign/serviceusage/ServiceUsageFee.java |
| 11.5 | src/chapter11_namedesign/maxhitpoint/OriginalMaxHitPoint.java |
| 11.6 | src/chapter11_namedesign/maxhitpoint/CorrectedMaxHitPoint.java |
| 11.8 | src/chapter11_namedesign/insidelogicname/v1/Magic.java |
| 11.9 | src/chapter11_namedesign/insidelogicname/v2/Magic.java |
| 11.11 | src/chapter11_namedesign/orders/v1/Order.java |
| 11.12 | src/chapter11_namedesign/orders/v2/Order.java |
| 11.13 | src/chapter11_namedesign/product/v1/ProductInfo.java |
| 11.14 | src/chapter11_namedesign/product/v2/ProductDto.java |
| 11.18 | src/chapter11_namedesign/manager/MemberManager.java |
| 11.19 | src/chapter11_namedesign/gerund/Enemy.java |
| 11.20 | src/chapter11_namedesign/gerund/PartyItems.java |
| 11.21 | src/chapter11_namedesign/booleanmethod/v1/Common.java |
| 11.22 | src/chapter11_namedesign/booleanmethod/v2/Member.java |

## 12章 コメント ―保守と変更の正確性を高める書き方―

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 12.2 | src/chapter12_comment/v1/Member.java |
| 12.3 | src/chapter12_comment/v2/Member.java |
| 12.5 | src/chapter12_comment/v3/Member.java |
| 12.6 | src/chapter12_comment/v4/Member.java |
| 12.7 | src/chapter12_comment/Money.java |

## 13章 メソッド（関数） ―良きクラスには良きメソッドあり―

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 13.1 | src/chapter13_method/Person.java |
| 13.2 | src/chapter13_method/commandquery/ModifireLogic.java |
| 13.3 | src/chapter13_method/commandquery/CommandQueryLogic.java |
| 13.4 | src/chapter13_method/returnvalue/v1/Price.java |
| 13.5 | src/chapter13_method/returnvalue/v1/MoneysLogic.java |
| 13.7 | src/chapter13_method/returnvalue/v2/Price.java |
| 13.8 | src/chapter13_method/returnvalue/v2/MoneysLogic.java |
| 13.9 | src/chapter13_method/doublemeaning/v1/Location.java |
| 13.10 | src/chapter13_method/doublemeaning/v2/Location.java |

## 15章 リファクタリング ―既存コードを成長に導く技―

| 本文のリスト番号 | 対応ファイル |
|:--|:--|
| 15.1 | src/chapter15_refactoring/webcomic/v1/PurchasePointPayment.java |
| 15.2 | src/chapter15_refactoring/webcomic/v2/PurchasePointPayment.java |
| 15.3 | src/chapter15_refactoring/webcomic/v3/PurchasePointPayment.java |
| 15.4 | src/chapter15_refactoring/webcomic/v4/PurchasePointPayment.java |
| 15.5 | src/chapter15_refactoring/webcomic/v5/PurchasePointPayment.java |
| 15.6 | src/chapter15_refactoring/webcomic/Customer.java |
| 15.7 | src/chapter15_refactoring/webcomic/v6/PurchasePointPayment.java |
| 15.8 | src/chapter15_refactoring/delivery/v1/DeliveryManager.java |
| 15.9 | src/chapter15_refactoring/delivery/v2/ShoppingCart.java |
| 15.10 | src/chapter15_refactoring/delivery/v2/Product.java |
| 15.11 | src/chapter15_refactoring/delivery/v2/DeliveryCharge.java |
| 15.12 | test/chapter15_refactoring/delivery/v3/DeliveryChargeTest.java |
| 15.13 | src/chapter15_refactoring/delivery/v3/DeliveryCharge.java |
| 15.14 | src/chapter15_refactoring/delivery/v4/DeliveryCharge.java |
| 15.15 | src/chapter15_refactoring/delivery/v5/ShoppingCart.java |
| 15.16 | src/chapter15_refactoring/delivery/v5/DeliveryManager.java |
| 15.17 | src/chapter15_refactoring/delivery/v5/DeliveryCharge.java |
| 15.18 | src/chapter15_refactoring/delivery/v6/ShoppingCart.java |
| 15.19 | src/chapter15_refactoring/delivery/v6/DeliveryCharge.java |
| 15.20 | src/chapter15_refactoring/delivery/v7/DeliveryCharge.java |
| 15.21 | src/chapter15_refactoring/delivery/v8/DeliveryCharge.java |
| 15.22 | src/chapter15_refactoring/delivery/v8/ShoppingCart.java |
